#!/usr/local/bin/perl -w
#
# adminmain.pl 
# accepts sid
#
use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}


#****** again doing some validation before displaying the page so that we can redirect
$userid = get_session_user($sid);
$lastitem = get_session_lastitem($sid);

if (!defined($userid) || $userid==0)
{
    print redirect ("shop.pl?sid=$sid&pid=$lastitem");
    exit(0);
}

if (get_user_type($userid) == 1) # 1 is user, 2 is admin
{
    print redirect ("shop.pl?sid=$sid&pid=$lastitem");
    exit(0);
}

disp_start_page();

disp_top_line($sid);

disp_left_pane($sid);


##***** start the actual page

$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

$sellength = 40;
#collect strings to be displayed in drop down lists

$userstr = "<select name=selecteduser size=1>\n";
$sth = $dbh->prepare("select userid, username, name  from user where usertype=\"user\";");
$sth->execute();
while ( $t = $sth->fetchrow_arrayref() )
{
    $addstr = ($t->[1]).": ".($t->[2]);
    if (length($addstr) > $sellength)
    {
	$addstr = (substr($addstr, 0, $sellength-3))."...";
    }
    $userstr = $userstr."<OPTION VALUE=".($t->[0])."> ".$addstr." </OPTION>\n";
}
$sth->finish();
$userstr=$userstr."</select>\n";

$adminstr = "<select name=selectedadmin size=1>\n";
$sth = $dbh->prepare("select userid, username, name from user where usertype=\"admin\" and userid != 1000;");
$sth->execute();
while ( $t = $sth->fetchrow_arrayref() )
{
    $addstr = ($t->[1]).": ".($t->[2]);
    if (length($addstr) > $sellength)
    {
	$addstr = (substr($addstr, 0, $sellength-3))."...";
    }
    $adminstr = $adminstr."<OPTION VALUE=".($t->[0])."> ".$addstr." </OPTION>\n";
}
$sth->finish();
$adminstr=$adminstr."</select>\n";


$prodstr = "<select name=selectedprod size=1>\n";
$sth = $dbh->prepare("select prodid, name from product;");
$sth->execute();
while ( $t = $sth->fetchrow_arrayref() )
{
    $addstr = $t->[1];
    if (length($addstr) > $sellength)
    {
	$addstr = (substr($addstr, 0, $sellength-3))."...";
    }
    $prodstr = $prodstr."<OPTION VALUE=".($t->[0])."> ".$addstr." </OPTION>\n";
}
$sth->finish();
$prodstr=$prodstr."</select>\n";

$catstr = "<select name=selectedcat size=1>\n";
$sth = $dbh->prepare("select distinct catid, catname from prodcat");
$sth->execute();
while ( $t = $sth->fetchrow_arrayref() )
{
    $addstr = $t->[1];
    if (length($addstr) > $sellength)
    {
	$addstr = (substr($addstr, 0, $sellength-3))."...";
    }
    $catstr = $catstr."<OPTION VALUE=".($t->[0])."> ".$addstr." </OPTION>\n";
}
$sth->finish();
$catstr=$catstr."</select>\n";

if (defined($t = param("errnum")))
    {
	if ($t == 50)
	{
	    print "<p><span class=errmsg> You have removed a category. So you need to edit the products which were in that category and change their category to some existing category, so that they remain accessible. </span> <br>";
	}
	else
	{
	    print "<p><span class=errmsg> There was an error number $t. Did you try to delete/remove when there was no item in the list? </span> <br>";
	}
    }

print <<ABC;

<form method=post action="admprocess.pl">
<input type=hidden name=sid value=$sid>

<table>

<tr> <td colspan=2> <h2> Website Administration <h2> </td> </tr>

<tr><td>

<p><b>Users</b>

<p><input type=submit name=adduser value="Add New User">

<p>$userstr<input type=submit name=edituser value="Edit">

<input type=submit name=remuser value="Remove">

<td>

<p><b>Administrators</b> <span class=small><span class=small>(excluding super-admin)</span></span>

<p><input type=submit name=addadmin value="Add New Administrator">

<p>$adminstr<input type=submit name=editadmin value="Edit">

<input type=submit name=remadmin value="Remove">

<tr><td>

<p><b>Product Categories</b>

<p><input type=submit name=addcat value="Add New Category">

<p>$catstr<input type=submit name=editcat value="Edit">

<input type=submit name=remcat value="Remove">

<td>

<p><b>Products</b>

<p><input type=submit name=addprod value="Add New Product">

<p>$prodstr<input type=submit name=editprod value="Edit">

<input type=submit name=remprod value="Remove">

</table>
</form>

ABC

##***** end the actual page

disp_bot_line($sid);

exit(0);
