#!/usr/local/bin/perl -w
#
# admprocess.pl 
# accepts sid; and a lot of form stuff
#
use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

# actual stuff
if ( !defined($t=get_session_user($sid)) || get_user_type(get_session_user($sid)) != 2)
{
    print redirect("shop.pl?sid=$sid");
    exit(0);
}

if (param("adduser"))
{
    print redirect("editprofile.pl?sid=$sid&userid=0&usertype=1&toadmin=1");
    exit(0);
}
elsif (param("edituser"))
{
    $t = param("selecteduser");
    if (!defined($t) || !$t)
    {
	print redirect("adminmain.pl?sid=$sid&errnum=1");
	exit(0);
    }
    print redirect("editprofile.pl?sid=$sid&userid=$t&usertype=1&toadmin=1");
    exit(0);
}
elsif (param("remuser"))
{
    $t = param("selecteduser");
    if (!defined($t) || !$t)
    {
	print redirect("adminmain.pl?sid=$sid&errnum=5");
	exit(0);
    }

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
   
    #remove any shopping cart held by the user
    if ($k = get_user_prevcartid($t))
    {
	$dbh->do("delete from cart where cartid=$k;");
    }
    
    $dbh->do("update session SET userid=NULL where userid=$t;"); #any session of that user should no longer be his!

    #remove the user
    $dbh->do("delete from user where userid=$t;"); #remove user

    $dbh->disconnect();
}
elsif (param("addadmin"))
{
    print redirect("editprofile.pl?sid=$sid&userid=0&usertype=2&toadmin=1");
    exit(0);
}
elsif (param("editadmin"))
{
    $t = param("selectedadmin");
    if (!defined($t) || !$t)
    {
	print redirect("adminmain.pl?sid=$sid&errnum=4");
	exit(0);
    }
    print redirect("editprofile.pl?sid=$sid&userid=$t&usertype=2&toadmin=1");
    exit(0);
}
elsif (param("remadmin"))
{
    $t = param("selectedadmin");
    if (!defined($t) || !$t)
    {
	print redirect("adminmain.pl?sid=$sid&errnum=5");
	exit(0);
    }

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
   
    #remove any shopping cart held by the user
    if ($k = get_user_prevcartid($t))
    {
	$dbh->do("delete from cart where cartid=$k;");
    }
    
    $dbh->do("update session SET userid=NULL where userid=$t;"); #any session of that user should no longer be his!

    #remove the user
    $dbh->do("delete from user where userid=$t;"); #remove user

    $dbh->disconnect();
}
elsif (param("addcat"))
{
    print redirect("editcat.pl?sid=$sid&catid=0");
    exit(0);
}
elsif (param("editcat"))
{
    $t = param("selectedcat");
    if (!defined($t) || !$t)
    {
	print redirect("adminmain.pl?sid=$sid&errnum=7");
	exit(0);
    }
    print redirect("editcat.pl?sid=$sid&catid=$t");
    exit(0);
}
elsif (param("remcat"))
{
    $t = param("selectedcat");
    if (!defined($t) || !$t)
    {
	print redirect("adminmain.pl?sid=$sid&errnum=8");
	exit(0);
    }

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
   
    $t = $dbh->do("delete from prodcat where catid=$t;");
    
    $dbh->disconnect();
    
    if ($t != 1)
    {
	print redirect("adminmain.pl?sid=$sid&errnum=9");
	exit(0);
    }
    
    #we are successful, but we need to display one warning messages to the user, so we set a particular error number
    print redirect("adminmain.pl?sid=$sid&errnum=50");
    exit(0);

}
elsif (param("addprod"))
{
    print redirect("editproduct.pl?sid=$sid&prodid=0");
    exit(0);
}
elsif (param("editprod"))
{
    $t = param("selectedprod");
    if (!defined($t) || !$t)
    {
	print redirect("adminmain.pl?sid=$sid&errnum=10");
	exit(0);
    }
    print redirect("editproduct.pl?sid=$sid&prodid=$t");
    exit(0);
}
elsif (param("remprod"))
{
    $t = param("selectedprod");
    if (!defined($t) || !$t)
    {
	print redirect("adminmain.pl?sid=$sid&errnum=11");
	exit(0);
    }

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
   
    $dbh->do("delete from product where prodid=$t;");
   
    $sth=$dbh->prepare("select cartid from cart where prodid=$t");
    $sth->execute();
    while ($cid = $sth->fetchrow_array())  #gets the first field instead of the row - scalar context
    {
	$dbh->do("delete from cart where cartid=$cid AND prodid=$t;");
	
	#now check whether all the items for this shopping cart have been erased
	$sth2 = $dbh->prepare("select cartid from cart where cartid=$cid;");
	$sth2->execute();
	if ( !($sth2->fetchrow_arrayref()) )
	{
 	    #then erase it from any session it was associated with 
	    $dbh->do("update session SET cartid=NULL where cartid=$cid;");
	    
	    #erase it also from any prevcartid it was associated with
	    $dbh->do("update user SET prevcartid=NULL where prevcartid=$cid;");
	}
        $sth2->finish();
    }

    $dbh->disconnect();
    
}

print redirect("adminmain.pl?sid=$sid");

exit(0);



