#!/usr/local/bin/perl -w
#
# cart.pl 
# accepts sid; operation: 1 = Add, 2 = Del, 3 = DelAll, 4 = View; operand, quantity; infomsg = {1,2}
#
#

use CGI qw/:standard :cgi-lib/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

disp_start_page();

disp_top_line($sid);

disp_left_pane($sid);


##******** start the actual page
$params = Vars();

$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

$cid = get_session_cart($sid);  # assign the current cart to $cid

if ($params->{"operation"})
{
    if ($params->{"operation"} == 1)
    {
	# Add a new item to the shopping cart
	if (int($params->{"quantity"})>=1)
	{
	    if (!defined($cid)) 
	    {                        
		#there is no cart, so lets get a new number
		$cid = get_next_id("select cartid from cart where cartid=");
		
		#and register it with the session
		$dbh->do("update session SET cartid=$cid where sessionid=$sid;");
	    }
	    
	    # add the item to the shopping cart
	    add_item_to_cart($cid, ($params->{"operand"}), int($params->{"quantity"}));
	}

    }
    elsif ($params->{"operation"} == 2)
    {
	#delete an item
	if ($cid)
	{
	    $dbh->do("delete from cart where cartid=$cid AND prodid=".($params->{"operand"}).";");
	    
	    #now check whether all the items for this shopping cart have been erased
	    $sth = $dbh->prepare("select cartid from cart where cartid=$cid;");
	    $sth->execute();
	    if ( !($sth->fetchrow_arrayref()) )
	    {
		#then erase it from session also 
		$dbh->do("update session SET cartid=NULL where sessionid=$sid;");
		$cid = 0;
	    }
	    $sth->finish();
	}
	
    }
    elsif ($params->{"operation"} == 3)
    {
	#delete all the items in the shopping cart
	if ($cid)
	{
	    $dbh->do("delete from cart where cartid=$cid;");
	    $dbh->do("update session SET cartid=NULL where sessionid=$sid;"); #update session
	    $cid = 0;
	}
    }
    else # it is 4 .. View
    {
	#nothing to do for view
    }
}

#display the shopping cart

if ($zzz = $params->{"infomsg"})
{
    if ($zzz == 1)
    {
	print "<p class=errmsg>You did not checkout your shopping cart last time. Would you like to checkout now?</p><br>";
    }
    elsif ($zzz == 2)
    {
	print "<p class=errmsg>You did not checkout your shopping cart last time. ";
	print "Its items have been added to the current shopping cart.</p><br>";
    }
}

print "<h2>Shopping Cart</h2>";
print "<p><table border class=shopcart width=100\%>";
print "<tr><th>Item No.<th> Product Name <th> Quantity <th> Rate <th> Total Price <th> &nbsp; </tr>";

if ($cid)
{
    $sth = $dbh->prepare("select prodid, quant from cart where cartid=$cid;");
    $sth->execute();
    $itemno = 0;
    $tot = 0;

    while ( $t = $sth->fetchrow_arrayref() )
    {
	$itemno++;

	$sth2 = $dbh->prepare("select name, price from product where prodid=".$t->[0].";");
	$sth2->execute();
	$t1 = $sth2->fetchrow_arrayref();
	
	print "<tr><td align=center> $itemno. <td>", $t1->[0], "<td align=right>", $t->[1], "<td align=right>", $t1->[1];
	print "<td align=right>", ($t->[1])*($t1->[1]);
	print "<td align=center> <a href= \"cart.pl?sid=$sid&operation=2&operand=".$t->[0]."\">Delete From Cart</a></tr>\n";
	
	$tot += (($t->[1])*($t1->[1]));

	$sth2->finish();
    }
    $sth->finish();
    
    print "<tr><td colspan=4> <b>Total Cost</b>: <td align=right>$tot </td><td>&nbsp;</td></tr>";

    print "</table>";

    print "<table width=100\%><tr>";
    print "<form name=emptyshopcart action=cart.pl method=post>";
    print "<input type=hidden name=sid value=$sid>";
    print "<input type=hidden name=operation value=3>";
    print '<td align=center><input type="submit" value="Empty Shopping Cart"></td>';
    print "</form>";

    print "<form name=checkout action=confirmorder.pl method=post>";
    print "<input type=hidden name=sid value=$sid>";
    print '<td align=center><input type="submit" value="Check Out"></td></tr>';
    print "</form>";
    print "</table>";

    #print "<p> <a href= \"cart.pl?sid=$sid&operation=3\">Empty Shopping Cart</a></p>\n";
    
}
else
{
    print "</table><p><b> Cart is empty </b></p>";
}


$dbh->disconnect();


##******* end the actual page

disp_bot_line($sid);

exit(0);
