#!/usr/local/bin/perl -w
#
# confirmorder.pl 
# accepts sid
#
use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

#--- a little paranioa, we break the rule, and put this before our library display functions, since we need to redirect
$cartid = get_session_cart($sid);
$userid = get_session_user($sid);
$lastitem = get_session_lastitem($sid);

if (!defined($cartid) || $cartid == 0)
{
    print redirect("shop.pl?sid=$sid&pid=$lastitem");
    exit(0);
}

if (!defined($userid) || $userid == 0)
{
    print redirect("login.pl?sid=$sid&toconfirmorder=1");
    exit(0);
}
#---

disp_start_page();

disp_top_line($sid);

disp_left_pane($sid);

$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );


print "<p><h2>Confirm Order</h2>";

print "<p>You are about to place order for the following: ";

$sth = $dbh->prepare("select prodid, quant from cart where cartid=$cartid;");
$sth->execute();

$tot = 0;

print "<p><table border cellpadding=2><tr><th>Product<th>Quantity</tr>";
while ( $t = $sth->fetchrow_arrayref() )
{
    $sth2 = $dbh->prepare("select name, price from product where prodid=".$t->[0].";");
    $sth2->execute();
    $t1 = $sth2->fetchrow_arrayref();
    
    print "<tr><td>", $t1->[0], "<td align=right>", $t->[1];
    
    $tot += (($t->[1])*($t1->[1]));
    
    $sth2->finish();
}

$sth->finish();

print "</table>";
print "<p> The total cost of this purchase order is: <b>\$$tot</b>";

print "<br><br><p> Following is the billing information for the purchaser: ";

$sth = $dbh->prepare("select name,address,city,state,zip,phone,email,cc,ccexp,username,password from user where userid=$userid;"); 
$sth->execute();
$user = $sth->fetchrow_arrayref();

print <<PRINTBLOCK;

<p>Name: $user->[0]
<br>Address: $user->[1]
<br>City:  $user->[2] &nbsp;&nbsp;&nbsp;&nbsp;&nbsp State: $user->[3] &nbsp;&nbsp; Zip: $user->[4]
<p>Credit Card: $user->[7]
<br>Credit Card Expiry: $user->[8]

<br>
<p>After verifying all of the information above, press the button below to go ahead with the order
<br>
<br>
<form action="placeorder.pl" method=post>

<input type=hidden name=sid value=$sid>

<center><input type=submit value="Place Order"></center>

</form>

PRINTBLOCK

$sth->finish();
$dbh->disconnect();

##***** end the actual page

disp_bot_line($sid);

exit(0);
