#!/usr/local/bin/perl -w
#
# editproduct.pl 
# accepts sid; errnum, prodid
#

use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

if (!defined(get_session_user($sid)) || get_user_type(get_session_user($sid)) != 2) 
{ #hehe! only admin people can access this page, somebody is trying spoof us!!!
    print redirect("shop.pl?sid=$sid");
    exit(0);
}

my_disp_start_page();  #NOTE: THIS IS DIFFERENT, SINCE WE WANT TO PUT A SCRIPT IN <HEAD>
                      #this function is at the bottom of this file  

disp_top_line($sid);

disp_left_pane($sid);


##***** start the actual page

$prodid = param("prodid");
$errnum = param("errnum");

if ($errnum)
{
    @arr_err_name = ("Nothing", "Name", "Price", "Description", "Specifications", "Review", "Category");
    
    if ($errnum >= 1 && $errnum <=6)
    {
	print "<br><span class=errmsg>The data you entered in the ".$arr_err_name[$errnum]." field had an incorrect format.</span>";
    }
    else
    {
	print "<br><span class=errmsg>There was an unpredicted error number $errnum, the profile was NOT stored. Please try again.</span>";
    }
}

$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

if ( !defined($prodid) || ($prodid==0) )
{
    $prodid = 0;
    print "<h2>Add New Product</h2><br>";
}
else
{
    $sth = $dbh->prepare("select name,descr,specs,review,price,picture,catid from product where prodid=$prodid;"); 
    $sth->execute();
    $prod = $sth->fetchrow_arrayref();

    print "<h2>Edit Product Profile</h2><br>";
}

#get category info
$sellength = 45;
$catstr = "<select name=selectedcat size=1>\n";
$sth = $dbh->prepare("select distinct catid, catname from prodcat;");
$sth->execute();
while ( $t = $sth->fetchrow_arrayref() )
{
    $addstr = ($t->[0]).": ".($t->[1]);
    if (length($addstr) > $sellength)
    {
	$addstr = (substr($addstr, 0, $sellength-3))."...";
    }
    if (defined($prod->[6]) && ($prod->[6])==($t->[0]))
    {
	$catstr = $catstr."<OPTION SELECTED VALUE=".($t->[0])."> ".$addstr." </OPTION>\n";
    }
    else
    {
	$catstr = $catstr."<OPTION VALUE=".($t->[0])."> ".$addstr." </OPTION>\n";
    }
}
$sth->finish();
$catstr=$catstr."</select>\n";

print <<PRINTBLOCK;

<form name=form1 onsubmit='return validate_form()' action="storeproduct.pl" method=post enctype="multipart/form-data">
<input type=hidden name=sid value=$sid>
<input type=hidden name=prodid value=$prodid>

<center><img src=$prod->[5] alt="the product picture"></center>
<p>Upload New Picture: <input type=file name=picture> <br>
(If you leave this blank, the current picture will be retained)<br>

<p>Name: <input type=text name=name size=50 maxlength=55 value="$prod->[0]">

<p>Price: <input type=text name=price size=10 maxlength=12 value="$prod->[4]">

<p>Category in which to place this product: 
$catstr

<p>Description of the Product:<br> <textarea name=descr rows=5 cols=60>$prod->[1]</textarea>

<p>Specifications of the Product:<br> <textarea name=specs rows=5 cols=60>$prod->[2]</textarea>

<p>Reviews for the Product:<br> <textarea name=review rows=5 cols=60>$prod->[3]</textarea>

<center><input type=submit value="Submit Information"> </center>

</form>

PRINTBLOCK

if ($prodid)
{
    $sth->finish();
}

$dbh->disconnect();

##***** end the actual page

disp_bot_line($sid);

exit(0);


sub my_disp_start_page
{
    print header();
    print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
    print "<html><head><title>Amazone: Your gateway to shopping</title>";
    print '<link rel="stylesheet" type="text/css" href="hw2.css" >';

    print <<PRINTBLOCKSCRIPT;

<script language="javascript">

function validate_form()
{    

var f = document.form1;

if (f.name.value == "")
{
   alert("You have not filled the Name. Please refill and try again.");
   return false;
}

if (f.price.value == "")
{
   alert("You have not filled the Price. Please refill and try again.");
   return false;
}
if ( !((f.price.value * 1) > 0) )
{
   alert("Price is not in the correct format. Please refill and try again.");
   return false;
}

if (f.descr.value == "")
{
   alert("You have not filled the Description. Please refill and try again.");
   return false;
}

if (f.specs.value == "")
{
   alert("You have not filled the Specifications. Please refill and try again.");
   return false;
}

if (f.review.value == "")
{
   alert("You have not filled the Review. Please refill and try again.");
   return false;
}

return true;
}
</script>
PRINTBLOCKSCRIPT
    
    print "</head><body>";
    print "<div class=headstyle> <h1>Amazone</h1> </div>";
    print "<br>";

}
