#!/usr/local/bin/perl -w
#
# editprofile.pl 
# accepts sid; toconfirmorder, toadmin; errnum, userid, usertype
#

use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

my_disp_start_page();  #NOTE: THIS IS DIFFERENT, SINCE WE WANT TO PUT A SCRIPT IN <HEAD>
                      #this function is at the bottom of this file  

disp_top_line($sid);

disp_left_pane($sid);


##***** start the actual page

$toconfirmorder = param("toconfirmorder");
$toadmin = param("toadmin");
$userid = param("userid");  #the user to edit profile of, 0 if a new profile is being created
$usertype = param("usertype");  # the type of the user, if a new user profile is being created
$errnum = param("errnum");

if ($userid || $usertype)
{
    # userid or usertype can only be set from the admin page by an administrator
    if (get_user_type(get_session_user($sid)) != 2) 
    { #hehe! somebody is trying spoof us!!!
	undef($usertype);
	undef($userid);
    }
}

if ($usertype && $usertype != 1 && $usertype != 2)
{
    $usertype = 1;
}

if ($userid && $userid == 1000)
{
    if (get_session_user($sid) != 1000)
    {
	undef($userid);
    }
}

if (!defined($userid))   
{
    #that means we have not been called from the admin page
    $userid = get_session_user($sid);  # in that case, if someone is logged in, then we assume that he is editing his profile
    if ($userid)
    {
	$usertype = get_user_type($userid);
    }
    else
    {
	$userid = 0;  #or if noone logged in, then somebody is trying to create a new user profile
	$usertype = 1;
    }
}

if ($errnum)
{
    @arr_err_name = ("Nothing", "Name", "Address", "City", "State", "Zip", "Phone", "Email", "Credit Card", "Credit Card Expiry Date", "Password", "Username");
    if ($errnum == 12)
    {
	print "<br><span class=errmsg>The Username already exists, please choose another one, and try again.</span>";
    }
    elsif ($errnum >= 1 && $errnum <=11)
    {
	print "<br><span class=errmsg>The data you entered in the ".$arr_err_name[$errnum]." field had an incorrect format.</span>";
    }
    else
    {
	print "<br><span class=errmsg>There was an unpredicted error number $errnum, the profile was NOT stored. Please try again.</span>";
    }

}


$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

print "<form name=form1 onsubmit='return validate_form()' action=storeprofile.pl method=post> \n";
print "<input type=hidden name=sid value=$sid>\n";
print "<input type=hidden name=userid value=$userid>";
print "<input type=hidden name=usertype value=$usertype>";

if ($toconfirmorder)
{
    print "<input type=hidden name=toconfirmorder value=$toconfirmorder>\n";
}

if ($toadmin)
{
    print "<input type=hidden name=toadmin value=$toadmin>\n";
}

if ( !defined($userid) || ($userid==0) )
{
    print "<h2>Create New User Profile</h2>";

    print "<table class=userprofile>";

    print "<tr><td>Username: </td> <td> <input type=text name=username size=10 maxlength=10></td></tr>\n";
}
else
{
    $sth = $dbh->prepare("select name,address,city,state,zip,phone,email,cc,ccexp,username,password from user where userid=$userid;"); 
    $sth->execute();
    $user = $sth->fetchrow_arrayref();

    print "<h2>Edit User Profile</h2>";

    print "<table class=userprofile>";

    print "<tr><td>Username: </td> <td><b> ".($user->[9])."</b> </td></tr>\n";
}

print <<PRINTBLOCK;

<tr> <td> Password: <br><span class=small>(min 3 chars)</span></td> <td> <input type=password name=password size=10 maxlength=10 value="$user->[10]"></td></tr>

<tr> <td> &nbsp; </td><td> &nbsp; </td></tr>

<tr> <td> Name: </td> <td> <input type=text name=name size=20 maxlength=25 value="$user->[0]"></td></tr>

<tr> <td> Address: </td> <td> <input type=text name=address size=20 maxlength=50 value="$user->[1]"></td></tr>

<tr> <td> City: </td> <td> <input type=text name=city size=20 maxlength=18 value="$user->[2]"></td></tr>

<tr> <td> State: </td> <td> <input type=text name=state size=2 maxlength=2 value="$user->[3]"></td></tr>

<tr> <td> Zip: </td> <td> <input type=text name=zip size=5 maxlength=5 value="$user->[4]"></td></tr>

<tr> <td> Phone: <br><span class=small>(no dashes,spaces)</span> </td> <td> <input type=text name=phone size=10 maxlength=10 value="$user->[5]"></td></tr>

<tr> <td> Email: </td> <td> <input type=text name=email size=20 maxlength=25 value="$user->[6]"></td></tr>

<tr> <td> &nbsp; </td><td> &nbsp; </td></tr>

<tr> <td> Credit Card: <br><span class=small>(no dashes,spaces)</span> </td> <td> <input type=text name=cc size=10 maxlength=10 value="$user->[7]"></td></tr>

<tr> <td> Expiry Date: <br><span class=small>(as mm/yy)</span> </td> <td> <input type=text name=ccexp size=5 maxlength=5 value="$user->[8]"></td></tr>

<tr> <td> &nbsp; </td><td> &nbsp; </td></tr>

<tr><td colspan=2><center><input type=submit value="Submit Information"> </center> </td></tr>

</table>

</form>


PRINTBLOCK

if ( $userid && $userid!=0)
{
    $sth->finish();
}

$dbh->disconnect();

##***** end the actual page

disp_bot_line($sid);

exit(0);


sub my_disp_start_page
{
    print header();
    print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
    print "<html><head><title>Amazone: Your gateway to shopping</title>";
    print '<link rel="stylesheet" type="text/css" href="hw2.css" >';

    print <<PRINTBLOCKSCRIPT;

<script language="javascript">

function validate_form()
{    

var f = document.form1;

if (f.name.value == "")
{
   alert("You have not filled the Name Field. Please refill and try again.");
   return false;
}

if (f.address.value == "")
{
   alert("You have not filled the Address Field. Please refill and try again.");
   return false;
}

if (f.city.value == "")
{
   alert("You have not filled the City Field. Please refill and try again.");
   return false;
}

if (f.state.value == "")
{
   alert("You have not filled the State Field. Please refill and try again.");
   return false;
}

if (f.zip.value == "")
{
   alert("You have not filled the Zip Field. Please refill and try again.");
   return false;
}

if (f.phone.value == "")
{
   alert("You have not filled the Phone Field. Please refill and try again.");
   return false;
}

if (f.email.value == "")
{
   alert("You have not filled the Email Field. Please refill and try again.");
   return false;
}

if (f.cc.value == "")
{
   alert("You have not filled the Credit Card Field. Please refill and try again.");
   return false;
}

if (f.ccexp.value == "")
{
   alert("You have not filled the Credit Card Expiry Date Field. Please refill and try again.");
   return false;
}

if (f.zip.value.length < 5)
{
    alert("Please fill a valid Zip Code, minimum 5 digits");
    return false;
}

for (j=0; j < f.zip.value.length; j++)
   if (!(f.zip.value.charAt(j)*1>=0 &&  f.zip.value.charAt(j)*1 <=9))
        {  
	alert("Please fill a valid ZIP code.");
	return false;
	}

if (f.phone.value.length < 10)
{
    alert("Please fill a valid Telephone number(10 digits.");
    return false;
}
    
for (j=0; j < f.phone.value.length; j++)
   if (!(f.phone.value.charAt(j)*1>=0 &&  f.phone.value.charAt(j)*1 <=9))
        {  
	    alert("Please fill a valid Telephone number(10 digits.");
	    return false;
	}

if (f.email.value.length <= 5 || f.email.value.indexOf("@") == -1 || f.email.value.indexOf(".") == -1)
{
  alert("Please fill in a valid email address.");
  return false;
}

if (f.cc.value.length < 10)
{
    alert("Please fill a valid Credit Card number(10 digits.");
    return false;
}
    
for (j=0; j < f.cc.value.length; j++)
   if (!(f.cc.value.charAt(j)*1>=0 &&  f.cc.value.charAt(j)*1 <=9))
        {  
	    alert("Please fill a valid Credit Card number(10 digits).");
	    return false;
	}

if (f.ccexp.value.length < 3)
{
    alert("Please fill a valid Credit Card expiry date(mm/yy).");
    return false;
}

for (j=0; j < f.ccexp.value.length; j++)
   if (f.ccexp.value.charAt(j) != "/" && !(f.ccexp.value.charAt(j)*1>=0 &&  f.ccexp.value.charAt(j)*1 <=9))
        {  
	    alert("Please fill a valid Credit Card expiry date(mm/yy).");
	    return false;
	}
 
if ( (f.ccexp.value.split("/")[0]*1) > 12 )
{
    alert("Please fill a valid Credit Card expiry date.");
    return false;
}

if (f.username)
{
    if (f.username.value.length < 3)
    {
	alert("Please fill a Username longer than 3 characters");
	return false;
    }
}

if (f.password.value.length < 3)
{
    alert("Please fill a Password longer than 3 characters");
    return false;
}

return true;
}
</script>
PRINTBLOCKSCRIPT
    
    print "</head><body>";
    print "<div class=headstyle> <h1>Amazone</h1> </div>";
    print "<br>";

}
