#!/usr/local/bin/perl -w
#
# managemain.pl 
# accepts sid, zip, city, state, datefrom, dateto, catid
#
use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}


#****** again doing some validation before displaying the page so that we can redirect
$userid = get_session_user($sid);
$lastitem = get_session_lastitem($sid);

if (!defined($userid) || $userid==0)
{
    print redirect ("shop.pl?sid=$sid&pid=$lastitem");
    exit(0);
}

if (get_user_type($userid) == 1) # 1 is user, 2 is admin
{
    print redirect ("shop.pl?sid=$sid&pid=$lastitem");
    exit(0);
}

my_disp_start_page();

disp_top_line($sid);

disp_left_pane($sid);


##***** start the actual page
#zip, city, state, datefrom, dateto, catid
$datefrom = param("datefrom");
$dateto = param("dateto");
$catid = param("selectedcat");
$zip = param("zip");
$city = param("city");
$state = param("state");

$datefrom =~ s/\"/\'/g;$dateto =~ s/\"/\'/g;$catid =~ s/\"/\'/g;$zip =~ s/\"/\'/g;
$city =~ s/\"/\'/g;$state =~ s/\"/\'/g;

$baddatefrom = $baddateto = $badzip = $badstate = "";

$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

if (!defined($catid))  { $catid = 1000; }

if  ($datefrom && ( ($datefrom !~ /\A(\d{1,2})\/(\d{1,2})\/(\d{4})\Z/) || ($1 < 1 || $1 > 12 || $2 < 1 || $2 > 31) ) )
{
    $baddatefrom = "<span class=errmsg>Removed due to incorrect format</span>";
    $datefrom = "";
}
elsif(!defined($datefrom))
{
    $datefrom = "";
}

if  ($dateto && ( ($dateto !~ /\A(\d{1,2})\/(\d{1,2})\/(\d{4})\Z/) || ($1 < 1 || $1 > 12 || $2 < 1 || $2 > 31) ) )
{
    $baddateto = "<span class=errmsg>Removed due to incorrect format</span>"; 
    $dateto = "";
}
elsif(!defined($dateto))
{
    $dateto = "";
}

if ($city && length($city) > 20) 
{
    $city = substr($city, 0, 20);
}
elsif(!defined($city))
{
    $city = "";
}

if ($state && $state !~ /\A[A-Za-z][A-Za-z]\Z/)
{
    $badstate = "<span class=errmsg>Removed due to incorrect format</span>";
    $state = "";
}
elsif(!defined($state))
{
    $state = "";
}

if ($zip && $zip !~ /\A\d{5}\Z/)
{
    $badzip = "<span class=errmsg>Removed due to incorrect format</span>";
    $zip = "";
}
elsif (!defined($zip))
{
    $zip = "";
}


#----
$sellength = 40;
$catstr = "<select name=selectedcat size=1>\n";
$catstr = $catstr."<option value=1000>All Categories</option>";
$sth = $dbh->prepare("select distinct catid, catname from prodcat");
$sth->execute();
while ( $t = $sth->fetchrow_arrayref() )
{
    $addstr = $t->[1];
    if (length($addstr) > $sellength)
    {
	$addstr = (substr($addstr, 0, $sellength-3))."...";
    }
    if ($t->[0] == $catid)
    {
	$catstr = $catstr."<OPTION SELECTED VALUE=".($t->[0])."> ".$addstr." </OPTION>\n";
    }
    else
    {
	$catstr = $catstr."<OPTION VALUE=".($t->[0])."> ".$addstr." </OPTION>\n";
    };
}
$sth->finish();
$catstr=$catstr."</select>\n";
#----

print "<h2> Sales Reports</h2>";

if (defined($t = param("errnum")))
    {
	print "<p><span class=errmsg> There was an error number $t.  </span> <br>";
    }

print <<ABC;

<p> Select criteria for filtering the results in the report <br>
<span class=small>(leaving a field blank is assumed to be equivalent to no filtering on that field)</span>
<p>
<form name=form1 method=post action="managemain.pl" onsubmit="return validate_form();">
<input type=hidden name=sid value=$sid>


<p>Enter Begin Date Here (mm/dd/yyyy): 
<input type=text name=datefrom size=10 maxlength=10 value="$datefrom">
$baddatefrom

<p>Enter End Date Here (mm/dd/yyyy): 
<input type=text name=dateto size=10 maxlength=10 value="$dateto">
$baddateto

<p>Enter City: <input type=text name=city size=15 maxlength=20 value="$city">

<p>Enter State: <input type=text name=state size=2 maxlength=2 value="$state">
$badstate

<p>Enter Zip: <input type=text name=zip size=5 maxlength=5 value="$zip">
$badzip

<p>Select Category here: 
$catstr

<p>
<center><input type=submit value="Submit"></center>

</form>

<p>

ABC

#prepare a query string from the filters

$querystr = 'select orderid, DATE_FORMAT(date,"%D %M, %Y"), catid, prodname, city, state, zip, price, quant from orders';

if ($datefrom)
{
    $datefrom =~ /\A(\d{1,2})\/(\d{1,2})\/(\d{4})\Z/;
    $t = "$3/$1/$2";
    add_to_query("TO_DAYS(date) >= TO_DAYS(\"$t\")");
}

if ($dateto)
{
    $dateto =~ /\A(\d{1,2})\/(\d{1,2})\/(\d{4})\Z/;
    $t = "$3/$1/$2";
    add_to_query("TO_DAYS(date) <= TO_DAYS(\"$t\")");
}

if ($city)
{
    add_to_query("UPPER(city) = UPPER(\"$city\")");
}

if ($state)
{
    add_to_query("UPPER(state) = UPPER(\"$state\")");
}

if ($zip)
{
    add_to_query("zip = \"$zip\"");
}

if ($catid && $catid != 1000)
{
    add_to_query("catid=$catid");
}

if ($querycond)
{
    $querystr = $querystr.$querycond;
}

#print "Executing $querystr";
print "<p>The report generated as per the criteria above is shown below.";

print "<p><table border><tr><th>Order No.<th>Date<th>Category<th>Product Name<th>city<th>state<th>zip<th>Sale Price</tr>";

$sth = $dbh->prepare($querystr);
$sth->execute();

$tot = 0;

while ($order = $sth->fetchrow_arrayref())
{
    print "<tr> <td>$order->[0]<td>$order->[1]<td>$order->[2]<td>$order->[3]<td>$order->[4]<td>$order->[5]<td>$order->[6]";
    
    $tot1 = ($order->[7]*$order->[8]);
    
    print "<td>$tot1";
    
    $tot += $tot1;
}

$sth->finish();

print "<tr><th colspan=7>Total Sales: <th>\$$tot";
print "</table>";

##***** end the actual page

disp_bot_line($sid);

exit(0);


sub my_disp_start_page
{
    print header();
    print '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
    print "<html><head><title>Amazone: Your gateway to shopping</title>";
    print '<link rel="stylesheet" type="text/css" href="hw2.css" >';

    print <<PRINTBLOCKSCRIPT;

<script language="javascript">

function validate_form()
{    

var f = document.form1;

if (f.datefrom.value != "")
{
    if (f.datefrom.value.length < 8)
    {
	alert("Please fill a valid Date-from date in the form (mm/dd/yyyy).");
	return false;
    }
    
    for (j=0; j < f.datefrom.value.length; j++)
    {
	if (f.datefrom.value.charAt(j) != "/" && !(f.datefrom.value.charAt(j)*1>=0 &&  f.datefrom.value.charAt(j)*1 <=9))
	{  
	    alert("Please fill a valid Date-from date in the form (mm/dd/yyyy).");
	    return false;
	}
    }
    
    if ( ((f.datefrom.value.split("/")[0]*1) > 12) || ((f.datefrom.value.split("/")[1]*1) > 31) )
    {
	alert("Please fill a valid Date-from date in the form (mm/dd/yyyy).");
	return false;
    }
}

if (f.dateto.value != "")
{
    if (f.dateto.value.length < 8)
    {
	alert("Please fill a valid Date-to date in the form (mm/dd/yyyy).");
	return false;
    }
    
    for (j=0; j < f.dateto.value.length; j++)
    {
	if (f.dateto.value.charAt(j) != "/" && !(f.dateto.value.charAt(j)*1>=0 &&  f.dateto.value.charAt(j)*1 <=9))
	{  
	    alert("Please fill a valid Date-to date in the form (mm/dd/yyyy).");
	    return false;
	}
    }
    
    if ( ((f.dateto.value.split("/")[0]*1) > 12) || ((f.dateto.value.split("/")[1]*1) > 31) )
    {
	alert("Please fill a valid Date-to date in the form (mm/dd/yyyy).");
	return false;
    }
}

if (f.state.value != "")
{
    if (f.state.value.length != 2)
	{
	    alert("Please fill a valid State field.");
	    return false;
	}

    if ( (f.state.value.charAt(0)*1>=0 &&  f.state.value.charAt(0)*1 <=9) ||
	 (f.state.value.charAt(1)*1>=0 &&  f.state.value.charAt(1)*1 <=9) )
    {  
	alert("Please fill a valid State field.");
	return false;
    }
}

if (f.zip.value != "")
{
    if (f.zip.value.length != 5)
    {
	alert("Please fill a valid ZIP code.");
	return false;
    }

    for (j=0; j < f.zip.value.length; j++)
    {
	if (!(f.zip.value.charAt(j)*1>=0 &&  f.zip.value.charAt(j)*1 <=9))
	{  
	    alert("Please fill a valid ZIP code.");
	    return false;
	}
    }
}

return true;
}
</script>
PRINTBLOCKSCRIPT
    
    print "</head><body>";
    print "<div class=headstyle> <h1>Amazone</h1> </div>";
    print "<br>";

}

sub add_to_query
{
    my $querytoadd = shift(@_);

    if ($querycond)
    {
	$querycond = "$querycond AND $querytoadd";
    }
    else
    {
	$querycond = " WHERE $querytoadd";
    }
}
