
$glob_db_string = "DBI:mysql:grkhetan_store1:localhost";
$glob_db_username = "grkhetan_store1";
$glob_db_password = "store1";

# handle_session(): Function
# Accepts argument: Session Id

# Returns: first: 0 - no error; 1 - session timeout
#          second: if there is no error, then the sid is returned as the second return arg
#                  you should reinitialize sid with this, since it can be different in case there was no sid before

sub handle_session
{
    my $sid = $_[0];
    my $dbh;
    my $sth;
    my $sth2;
    my $session;
    my @to_ret = ();

    $to_ret[0] = 0;
    
    #----first check and expire the timed out sessions
    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

    # 3 and a half min session timeout
    $sth = $dbh->prepare("select sessionid from session where DATE_SUB(NOW(), INTERVAL 210 SECOND) > timelast;");
#NOW() - timelast > \"00000000000200\";"); 
    $sth->execute();

    while ( $session = $sth->fetchrow_arrayref() )
    {
	# for each timed out session
	# erase the session and do necessary cart formalities
	erase_session($session->[0]);
    }
    
    $sth->finish();

    
    #------make sure we have a session, and that it has not timed out
    
    if ($sid)
    {
	#we have a session id
	
	#check whether it exists in the session table i.e. it has not timed out yet
	$sth2 = $dbh->prepare("select sessionid from session where sessionid=$sid;");
	$sth2->execute();
	if ($sth2->fetchrow_arrayref())
	{
	    #there is a good non-timed out session with our session id
	    #just update its timestamp
	    $dbh->do("update session SET timelast=NOW() where sessionid=$sid;");
	}
	else
	{
	    #there is no non-timed-out session equal to the one we have
	    #so our session has timed out
	    $to_ret[0] = 1; #set to_ret to 1 to indicate timeout
	}
	$sth2->finish();
    }
    else
    {
	#there is no session, sid is NULL
	#so create a new session
	
	$sid = get_next_id("select sessionid from session where sessionid=", 2147483646);
	
	$dbh->do("insert into session (sessionid, lastitem) VALUES ($sid, 1000);");

	#the timelast value will be updated automatically since we didnt write to that field, and wrote to another
    }
	
    $dbh->disconnect();
    $to_ret[1] = $sid;
    return(@to_ret);
}

#
# returns the userid of this session, if none, then returns "undefined"
# Accepts session id as parameter
#
sub get_session_user
{
    my $sid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

    $sth = $dbh->prepare("select userid from session where sessionid=$sid;");
    $sth->execute();
    
    if ($t = $sth->fetchrow_arrayref())
    {
	if ($t->[0] && $t->[0] != 0)
	{
	    $to_ret = $t->[0];
	}	
    }
    
    $sth->finish();
	
    $dbh->disconnect();
    return $to_ret;
}


#
# returns the cartid of this session, if none, then returns "undefined"
# Accepts session id as parameter
#
sub get_session_cart
{
    my $sid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
    
    $sth = $dbh->prepare("select cartid from session where sessionid=$sid;");
    $sth->execute();
    if ($t = $sth->fetchrow_arrayref())
    {
	if ($t->[0] && $t->[0] != 0)
	{
	    $to_ret = $t->[0];
	}
    }
    
    $sth->finish();
	
    $dbh->disconnect();
    return $to_ret;
}

#
# returns the lastitem of this session, if none, then returns "undefined"
# Accepts session id as parameter
#
sub get_session_lastitem
{
    my $sid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

    $sth = $dbh->prepare("select lastitem from session where sessionid=$sid;");
    $sth->execute();
    
    if ($t = $sth->fetchrow_arrayref())
    {
	if ($t->[0] && $t->[0] != 0)
	{
	    $to_ret = $t->[0];
	}
    }
    
    $sth->finish();
	
    $dbh->disconnect();
    return $to_ret;
}

# Accepts userid as argument, and returns name of the user
#

sub get_user_name
{
    my $uid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

    $sth = $dbh->prepare("select name from user where userid=$uid;");
    $sth->execute();
    if ($t = $sth->fetchrow_arrayref())
    {
	$to_ret = $t->[0];
    }
    
    $sth->finish();
	
    $dbh->disconnect();
    return $to_ret;
}


# Accepts userid as argument, and returns type of the user - 1 - normal user;  2 - admin
# Optional second dbh argument

sub get_user_type
{
    my $uid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;
    my $def = 1;
    
    if (!defined($_[1]))
    {
	$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
	$def = 0;
    }
    
    $sth = $dbh->prepare("select usertype from user where userid=$uid;");
    $sth->execute();
    if ($t = $sth->fetchrow_arrayref())
    {
	if ($t->[0] eq "user")
	{
	    $to_ret = 1;
	} 
	elsif ($t->[0] eq "admin")
	{
	    $to_ret = 2;
	}
    }
    
    $sth->finish();
	
    if ($def == 0)
    {
	$dbh->disconnect();
    }

    return $to_ret;
}


#this accepts sessionid as argument
# the session is erased from the session table, as well the cart is erased or remembered as necessary

sub erase_session
{
    my $sid = $_[0];
    
    my $cartid = get_session_cart($sid);
    my $userid = get_session_user($sid);

    my $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

    if ($cartid && $cartid != 0)
    {  
	#there is a cart
	if ($userid && $userid != 0)
	{
	    #there is a user, remember the cart for that user
	    $dbh->do("update user SET prevcartid=$cartid where userid=$userid;");
	}
	else
	{
	    #there is no user, so erase the cart
	    $dbh->do("delete from cart where cartid=$cartid;");
	}
    }
    
    # delete the session
    $dbh->do("delete from session where sessionid=$sid;");
    
    $dbh->disconnect();

}


# Accepts userid as argument, and returns prevcartid for that user
#

sub get_user_prevcartid
{
    my $uid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

    $sth = $dbh->prepare("select prevcartid from user where userid=$uid;");
    $sth->execute();
    if ($t = $sth->fetchrow_arrayref())
    {
	if ($t->[0] && $t->[0] != 0)
	{
	    $to_ret = $t->[0];
	}
    }
    
    $sth->finish();
	
    $dbh->disconnect();
    return $to_ret;
}

#
# accepts prodid as argument, returns its price from the product table
#
sub get_product_price
{
    my $pid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
    
    $sth = $dbh->prepare("select price from product where prodid=$pid;");
    $sth->execute();
    if ($t = $sth->fetchrow_arrayref())
    {
	$to_ret = $t->[0];
    }
    
    $sth->finish();
	
    $dbh->disconnect();
    return $to_ret;
}


#
# accepts prodid as argument, returns its category from the product table
#
sub get_product_category
{
    my $pid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
    
    $sth = $dbh->prepare("select catid from product where prodid=$pid;");
    $sth->execute();
    if ($t = $sth->fetchrow_arrayref())
    {
	$to_ret = $t->[0];
    }
    
    $sth->finish();
	
    $dbh->disconnect();
    return $to_ret;
}

#
# accepts catid as argument, returns its name from the category table
#
sub get_category_name
{
    my $cid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
    
    $sth = $dbh->prepare("select catname from prodcat where catid=$cid;");
    $sth->execute();
    if ($t = $sth->fetchrow_arrayref())
    {
	$to_ret = $t->[0];
    }
    
    $sth->finish();
    
    $dbh->disconnect();
    return $to_ret;
}

#
# accepts prodid as argument, returns its name from the product table
#
sub get_product_name
{
    my $pid = $_[0];
    my $dbh;
    my $sth;
    my $t;
    my $to_ret;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
    
    $sth = $dbh->prepare("select name from product where prodid=$pid;");
    $sth->execute();
    if ($t = $sth->fetchrow_arrayref())
    {
	$to_ret = $t->[0];
    }
    
    $sth->finish();
	
    $dbh->disconnect();
    return $to_ret;
}

#this function takes cartid as first, prodid as second, and quant as third argument
#it adds the product into the cart
#if there is already a row for that cartid with the same product, then it increases the quantity of that row
#else it adds another row
#returns nothing;

sub add_item_to_cart
{
    my $cid = shift(@_);
    my $prodid = shift(@_);
    my $quant = shift(@_);
    my $dbh;
    my $sth;
 
    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
    
    $sth = $dbh->prepare("select cartid from cart where cartid=$cid AND prodid=$prodid;");
    $sth->execute();
    if ( !($sth->fetchrow_arrayref()) )
    {
	#the same product is NOT present in the cart already
	#so we will have to add another row 	
	$dbh->do("insert into cart (cartid, prodid, quant) VALUES ($cid, $prodid, $quant);");
    }
    else
    {
	#there is already the same product in the cart, so instead of adding another row
	#increase the quantity of that row
	$dbh->do("update cart SET quant=quant+$quant where cartid=$cid AND prodid=$prodid;");
    }
    $sth->finish();
    $dbh->disconnect();
    
}


# this returns a new random id, and checks whether 
# require a database select str as an argument, to which the no being generated can be appended
# it is possible to specify a second argument which is the max number for the random no generation
sub get_next_id
{
    my $dbstr = $_[0];
    my $to_ret;
    my $max_num;
    my $dbh;
    my $sth;

    if ($_[1]) {
	$max_num = $_[1];
    }
    else {
	$max_num = 32000;
    }

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

    while(1)
    {
	$to_ret = int(rand($max_num)); 
	if ($to_ret == 0 || $to_ret == 1000)
	{
	    next;
	}
	$sth = $dbh->prepare($dbstr.$to_ret.";");
	$sth->execute();
	
	if ($sth->fetchrow_arrayref()) { 
	    $sth->finish(); next;
	}
	else {
	    $sth->finish(); last;
	}
    }
    $dbh->disconnect();

    return($to_ret);
}

#displays http header, html head, the amazone logo
# does not require any argument
sub disp_start_page
{
    print header();

    print start_html( { -title => 'Amazone: Your gateway to shopping',
			-author => 'grkhetan@yahoo.com',
			-style => {'src'=>'hw2.css'} } );
    
    print "<div class=headstyle> <h1>Amazone</h1> </div>";
    
    print "<br>";
}


#displays the top line
# Accepts Session ID as argument
sub disp_top_line
{
    my $sid = $_[0];
    my $uid;
    my $t;

    print "\n",'<table width=100% cellpadding=0 cellspacing=0>';
    print "<tr class=small><td colspan=3 align=center>&nbsp;";
    if ($timeout) { print "<span class=errmsg>Session has timed out!! A new session was started. </span>"; }
    print "<td align=right>", ($t = localtime()), "</tr>";

    if ($uid = get_session_user($sid))
    {
	print "<tr class=topmenu>";

	print "<td width=33%>";
	
	print "Hi ", get_user_name($uid), "! ", '&nbsp;&nbsp;&nbsp;';
	print "<a href=\"cart.pl?sid=$sid&operation=4\">View Shopping Cart</a> ";
	
	if (get_user_type($uid) == 2)
	{
	    print "<td width=16%> <a class=adminlink href=\"adminmain.pl?sid=$sid\">Administration</a></td>";
	    print "<td width=16%> <a class=adminlink href=\"managemain.pl?sid=$sid\">Management</a></td>";
	}
	else
	{
	    print "<td width=16%> &nbsp; ";
	    print "<td width=16%> &nbsp; ";
	}

	print "<td align=right>"; 
	print "<a href=\"editprofile.pl?sid=$sid\">Edit Profile</a> ";
	print "<a href=\"orderhistory.pl?sid=$sid\">Order History</a> ";
	print "<a href=\"logout.pl?sid=$sid\">Log out</a>";
    }
    else
    {
	print "<tr class=topmenu>";

	print "<td width=\"33\%\">";
	
	print 'Welcome Guest!! &nbsp;&nbsp;&nbsp;';
	print "<a href=\"cart.pl?sid=$sid&operation=4\">View Shopping Cart</a> ";

	print "<td width=16%> &nbsp; ";
	print "<td width=16%> &nbsp; ";
	
	print "<td align=right>"; 
	print "<a href=\"login.pl?sid=$sid\">Log in</a> ";
	print "or <a href=\"editprofile.pl?sid=$sid\">Create a New Profile</a>";
    }

    print "</table>\n";
}


#displays categories on the left hand side
#requires sid as argument
#before returning it starts the <td> 

sub disp_left_pane
{
    my $sid = $_[0];
    my $dbh;
    my $sth;
    my $prodcat;

    $dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );
    
    print "<table width=100\% cellpadding=10 cellspacing=0>";

    print '<tr>';
    
    print '<td width=8\% class=leftpane>';

    print '<b>Categories</b><br>';
    
    print"<br><a href=\"shop.pl?sid=$sid&pid=1000\">Top</a>";

    $sth = $dbh->prepare("select catid, catname from prodcat;"); 
    $sth->execute();
    
    while ( $prodcat = $sth->fetchrow_arrayref() )
    {
	print '<br><a class=catlink href="shop.pl?sid='.$sid.'&pid='.$prodcat->[0].'">'.$prodcat->[1].'</a>'."\n";
    }
    $sth->finish();
    
    print "</td>";

    $dbh->disconnect();

    print "<td class=mainpane>"; #start the td for the caller
}

sub disp_bot_line
{
    my $sid = $_[0];

    print "</td></table>\n";
    
    print "<table width=100\% cellpadding=0 cellspacing=0>";
    print "<tr class=topmenu>";
    print "<td> <a href=\"about.pl?sid=$sid\">About This Site</a> ";
    print "&nbsp; &nbsp; &nbsp; <a href=\"contact.pl?sid=$sid\">Contact Us</a> ";
    print "<td class=topmenu align=right>Best Viewed in Mozilla at a resolution of 1024x768";
    print "</table>";

    print "<font size=-1> A Class Project. Not Real. </font> ";
    print end_html();
}

#
# disp_message(): Function
# Accepts: String to be displayed
# this function will create a header, a html page, and display the message
#

sub disp_message
{
    my $str = $_[0];

    print redirect("shop.pl?timeout=1");
    exit(1);

#    print header();
#    print start_html($str);
#    print p(), "<font size=\"+1\">", $str, "</font>";
#    print p(), "<a href=\"shop.pl\">Click here</a> to continue shopping.";
#    print end_html();
}


1;

