#!/usr/local/bin/perl -w
#
# orderhistory.pl 
# accepts sid; orderid //if null, displays all orders, if a specific value, display components of that order
#
use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

disp_start_page();

disp_top_line($sid);

disp_left_pane($sid);


##***** start the actual page
$orderid = param("orderid");
$userid = get_session_user($sid);

$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

print "<h2>Order History</h2> ";

if ($orderid && $orderid!=0)
{
    #display only items of this order orderid

    $sth = $dbh->prepare('select DATE_FORMAT(date,"%D %M, %Y; %h:%i%p") from orders where orderid='.$orderid.';');
    $sth->execute();
    $oiddate = $sth->fetchrow_array(); #this will only get the first field of the row
    $sth->finish();

    print "<p>Displaying all the items of the Order No. $orderid  dated $oiddate";
    
    print "<p><table border class=orderhisttable > ";
    
    print "<tr><th>Item No.<th> Product Name <th> Quantity <th> Rate <th> Total Price </tr>";

    $sth = $dbh->prepare("select prodname, quant, price from orders where orderid=$orderid;");
    $sth->execute();
    $itemno = 0;
    $tot = 0;

    while ( $t = $sth->fetchrow_arrayref() )
    {
	$itemno++;
	
	print "<tr><td align=center> $itemno. <td>", $t->[0], "<td align=right>", $t->[1], "<td align=right>", $t->[2];
	print "<td align=right>", ($t->[1])*($t->[2]);
	
	$tot += (($t->[1])*($t->[2]));
    }

    $sth->finish();
    
    print "<tr><td colspan=4> <b>Total Cost</b>: <td align=right>$tot </td></tr>";

    print "</table>";

    print "<p><a href=\"orderhistory.pl?sid=$sid \">Click here</a> to go back to complete order history";

}
else
{
    #display all the orders

    print "<p>Displaying your complete Order History";
    
    print "<p><table border class=orderhisttable> ";
    
    print "<tr><th>Date<th>Order No.</tr>";

    $sth = $dbh->prepare("select distinct orderid from orders where userid=$userid;");
    $sth->execute();

    $itemno = 0;

    while ( $oid = $sth->fetchrow_array() ) #this will get only the first field from the row
    {
	$itemno++;

	$sth2 = $dbh->prepare('select DATE_FORMAT(date,"%D %M, %Y; %h:%i%p") from orders where orderid='.$oid.';');
	$sth2->execute();
	$oiddate = $sth2->fetchrow_array(); #this will only get the first field of the row
	$sth2->finish();

	print "<tr><td align=center>$oiddate<td align=center><a href=\"orderhistory.pl?sid=$sid&orderid=$oid\"> $oid </a>";
    }

    $sth->finish();
    
    print "</table>";
    
    if ($itemno==0)
    {
	print "<p>No Orders Yet";
    }
    else
    {
	print "<p>Click on an order id to see the details of individual orders";
    }
    
}


$dbh->disconnect();


##***** end the actual page

disp_bot_line($sid);

exit(0);
