#!/usr/local/bin/perl -w
#
# placeorder.pl 
# accepts sid; operation: 1 = Add, 2 = Del, 3 = DelAll, 4 = View; operand, quantity
#
#

use CGI qw/:standard :cgi-lib/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

#--- a little paranioa, we break the rule, and put this before our library display functions, since we need to redirect
$cartid = get_session_cart($sid);
$userid = get_session_user($sid);
$lastitem = get_session_lastitem($sid);

if (!defined($cartid) || $cartid == 0 || !defined($userid) || $userid == 0)
{
    print redirect("shop.pl?sid=$sid&pid=$lastitem");
    exit(0);
}

#---

disp_start_page();

disp_top_line($sid);

disp_left_pane($sid);


##******** start the actual page

$orderid = get_next_id("select orderid from orders where orderid=");

$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

#move items from the shopcart to order table
$sth = $dbh->prepare("select prodid, quant from cart where cartid=$cartid;");
$sth->execute();
while ( $t = $sth->fetchrow_arrayref() )
{
    $price = get_product_price($t->[0]);
    $prodname = get_product_name($t->[0]);
    $catid = get_product_category($t->[0]);
    
    $sth2 = $dbh->prepare("select city, state, zip from user where userid=$userid;");
    $sth2->execute();
    $t2 = $sth2->fetchrow_arrayref();
    $city = $t2->[0];
    $state = $t2->[1];
    $zip = $t2->[2];

    $dbh->do("insert into orders (orderid, userid, prodid, quant, price, date, prodname, catid, city, state, zip) VALUES ($orderid, $userid, ".$t->[0].", ".$t->[1].", $price, NULL,\"$prodname\",$catid, \"$city\", \"$state\", \"$zip\" );");

    $sth2->finish();
}
$sth->finish();


#remove the shopping cart
$dbh->do("delete from cart where cartid=$cartid;");

#and erase it from our session
$dbh->do("update session SET cartid=NULL where sessionid=$sid;");

$dbh->disconnect();


#display confirmation

print "<br><br><p> Your order has been successfully placed. The order number is: $orderid";
 
print '<br><p><a href="orderhistory.pl?sid='.$sid.'">Click here</a> to see your order history';

print '<br><p><a href="shop.pl?sid='.$sid.'&pid='.$lastitem.'">Click here</a> to continue shopping by going back to where you left off';

##******* end the actual page

disp_bot_line($sid);

exit(0);

