#!/usr/local/bin/perl -w
#
# processlogin.pl 
# accepts sid; username; password; toconfirmorder
#
use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

#NOTE: WE ARE NOT DISPLAYING ANY PAGE IN THIS SCRIPT
#THIS SCRIPT WILL ONLY PROCESS AND REDIRECT TO OTHER PAGES

##***** start the actual page

$username = param("username");
$password = param("password");
$toconfirmorder = param("toconfirmorder");

$username =~ s/\"/\'/g;$password =~ s/\"/\'/g;

if (!defined($toconfirmorder))
{
    $toconfirmorder = 0;
}

#if nothing was entered in either username or password, we redirect to login.pl right away with wronglogin set
if (length($username) == 0 || length($password) == 0)
{
    print redirect("login.pl?sid=$sid&wronglogin=1&toconfirmorder=$toconfirmorder");
    exit(0);
}


$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

#validate username/password
$sth = $dbh->prepare("select userid from user where username=\"$username\" AND password=\"$password\";");
$sth->execute();
    
if ($t = $sth->fetchrow_arrayref())
{
    #there is a user with that username and password, good
    $userid = $t->[0];
}
else 
{
    #the username/password is wrong, redirect to login.pl with wronglogin set
    $sth->finish();
    $dbh->disconnect();
    print redirect("login.pl?sid=$sid&wronglogin=1&toconfirmorder=$toconfirmorder");
    exit(0);
}
$sth->finish();

# IMP: WE ENFORCE THAT ONE USER CAN NOT HAVE TWO SIMULTANEOUS SESSIONS
# SO IF THIS USER IS ALREADY LOGGED IN SOME SESSION, WE CANNOT ALLOW HIM TO GO AHEAD
# so check whether this user already has any logins in other sessions

$sth = $dbh->prepare("select sessionid from session where userid=$userid;");
$sth->execute();
if ($t = $sth->fetchrow_arrayref())
{
    #yes, there is, so redirect to login.pl with wronglogin set to 2
    $sth->finish();
    $dbh->disconnect();
    print redirect("login.pl?sid=$sid&wronglogin=2&toconfirmorder=$toconfirmorder");
    exit(0);
}
$sth->finish();


#set this session's userid to this userid
$dbh->do("update session SET userid=$userid where sessionid=$sid;"); #so we are logged in! ;)

#get prevcartid of this user
$prevcartid = get_user_prevcartid($userid);

if ($toconfirmorder == 1)
{
    #to confirm order is set, so we enforce that any previous cart of the user should be erased
    #since we are directly going to the confirm order page here and he will not like it 
    # when he sees sudden new items been placed in the order

    if ( $prevcartid && $prevcartid != 0)
    {
	$dbh->do("delete from cart where cartid=$prevcartid;");
    }

    $dbh->do("update user SET prevcartid=NULL where userid=$userid");

    $dbh->disconnect();
    
    print redirect("confirmorder.pl?sid=$sid");
    exit(0);
}

if ( $prevcartid && $prevcartid != 0)
{
    $zzz = 0;
    $cartid = get_session_cart($sid);
    if ($cartid && $cartid != 0)
    {
	# we already have a cart this session, so we are going to have to merge this and the prevcartid cart
	$zzz = 2;

	#copy all the items from prevcartid to cartid
	$sth= $dbh->prepare("select prodid, quant from cart where cartid=$prevcartid;");
	$sth->execute();
	while($t = $sth->fetchrow_arrayref())
	{
	    add_item_to_cart($cartid, $t->[0], $t->[1]);
	}
	$sth->finish();

	# and then erase the prevcartid
	$dbh->do("delete from cart where cartid=$prevcartid;");
    }
    else
    {
	#there is no cart here, so we just bring up the old cart as the current cart
	$zzz = 1;

	$dbh->do("update session SET cartid=$prevcartid where sessionid=$sid;"); 
    }

    #set prevcartid to be null in any case
    #we enforce that prevcartid is valid only between two login sessins of the user
    $dbh->do("update user SET prevcartid=NULL where userid=$userid");

    $dbh->disconnect();
    
    print redirect("cart.pl?sid=$sid&infomsg=$zzz");

    exit(0);
}

$dbh->disconnect();

$lastitem = get_session_lastitem($sid);
   
print redirect("shop.pl?sid=$sid&pid=$lastitem");

exit(0);
