#!/usr/local/bin/perl -w
#
# shop.pl 
# accepts sid; pid; timeout
#
use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable
$timeout = param("timeout");

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

disp_start_page();

disp_top_line($sid);

disp_left_pane($sid);


##***** start the actual page

$pid = param("pid"); #this is the product id -- the current product we are asked to display


$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

#update session's lastitem
if (!defined($pid)) 
{ 
    $pid = 1000; #if there is no product id, then take default 1000 which is the top category
}
$dbh->do("update session SET lastitem=$pid where sessionid=$sid;");

#we observe three cases of rendering here 

if (get_category_name($pid))  # this will return category name only if a category exists
{
    # 1. Category other than Top, which only contains products, no categories
    $sth = $dbh->prepare("select catname from prodcat where catid=$pid;");
    $sth->execute();
    $t = $sth->fetchrow_arrayref();
    $catname = $t->[0];
    $sth->finish();
    
    $sth = $dbh->prepare("select prodid, name, price, picture from product where catid=$pid;"); 
    $sth->execute();
    
    print "<center><b><h2>$catname</h2></b></center><br>";

    $counter = 0;

    print '<table width=100%>';
    
    while ( $prod = $sth->fetchrow_arrayref() )
    {
	$counter++;
	print '<tr><td width="50%" align=center>';
	print '<a href="shop.pl?sid='.$sid.'&pid='.$prod->[0].'">';
	print '<img src="', $prod->[3], '" alt="', $prod->[1], '" class=thumbnail></a>';
	print "<td><p><b>$prod->[1]</b><p>Price: \$$prod->[2]";
	print '<p><a href="shop.pl?sid='.$sid.'&pid='.$prod->[0].'">', "Click here for details</a>\n";
    }
    $sth->finish();
    print "</table>";
    if ($counter==0)
    {
	print "<p><p>Currently there are no products in this category.";
    }
}
elsif (get_product_price($pid))  #this will return product price only if a product exists
{
    # 2. Product Details page
    $sth2 = $dbh->prepare("select prodid, name, descr, specs, review, price, picture, catid from product where prodid=$pid;"); 
    $sth2->execute();
    $prod = $sth2->fetchrow_arrayref();
    
    #get the category name
    $sth = $dbh->prepare("select catname from prodcat where catid=".($prod->[7]).";");
    $sth->execute();
    $t = $sth->fetchrow_arrayref();
    $catname = $t->[0];
    
    print <<PRINTBLOCK;
    
<table width=100%>
<tr><td colspan=2>Category: <a href="shop.pl?sid=$sid&pid=$prod->[7]">$catname</a>
    
<tr>

<td width="50%" align=center><img src="$prod->[6]" alt="$prod->[1]">

<td><p class="big"><b>$prod->[1]</b><p>Price: \$$prod->[5]

<form action="cart.pl" method="post" onsubmit = "if (!((this.quantity.value*1)>=1)) { alert ('Quantity is not in the correct format'); return false; } return true;">
<input type=hidden name=sid value=$sid>
<input type=hidden name=operation value=1>
<input type=hidden name=operand value=$prod->[0]>

<p><label>Quantity: <input type="text" name=quantity size=3 maxlength=3 value=1></label>
<p><input type="submit" value="Add to Cart">

</form>

<tr><td colspan=2>
    
<dl>
<dt>Description:
<dd>$prod->[2]

<dt>Specifications:
<dd>$prod->[3]

<dt>Review:
<dd>$prod->[4]
</dl>

</table>
PRINTBLOCK

    $sth->finish();
    $sth2->finish();
}
else
{
    # 3. Category Top, which only contains other categories, no products , pid should be 1000

    if ($pid!=1000) { $pid = 1000; }

    print "<p><font size=+1>Categories</font>";
    print "<dl>";

    $sth = $dbh->prepare("select catid, catname, catdescr from prodcat;"); 
    $sth->execute();
    
    while ( $prodcat = $sth->fetchrow_arrayref() )
    {
	print '<dt><a class=catlink href="shop.pl?sid='.$sid.'&pid='.$prodcat->[0].'">'.$prodcat->[1].'</a>';
	print "<dd>", $prodcat->[2];
    }
    $sth->finish();
    print "</dl>";
}


$dbh->disconnect();

##***** end the actual page

disp_bot_line($sid);

exit(0);
