#!/usr/local/bin/perl -w
#
# storeproduct.pl 
# accepts sid; prodid; all form elements
#
use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

#NOTE: WE ARE NOT DISPLAYING ANY PAGE IN THIS SCRIPT
#THIS SCRIPT WILL ONLY PROCESS AND REDIRECT TO OTHER PAGES

##***** start the actual page

if (!defined(get_session_user($sid)) || get_user_type(get_session_user($sid)) != 2) 
{ #hehe! only admin people can access this page, somebody is trying spoof us!!!
    print redirect("shop.pl?sid=$sid");
    exit(0);
}

$prodid = param("prodid");

$name = param ("name");
$price = param ("price");
$descr = param("descr");
$specs = param ("specs");
$review = param ("review");
$catid = param("selectedcat");
$infile = upload("picture");  #if the file upload is completed properly, then this will contain a file handle, else undef

$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

if (!defined($prodid))
{
    khatam(7);
}

$name =~ s/\"/\'/g; $price =~ s/\"/\'/g; $descr =~ s/\"/\'/g; $specs =~ s/\"/\'/g; $review =~ s/\"/\'/g;
$catid =~ s/\"/\'/g;

#----------start data validation
if ($name !~ /\S+/) {
    khatam(1);
}

if (($price !~ /\A\d+\Z/) && ( ($price !~ /\A\d*\.\d*\Z/) || ($price !~ /\d/))) {
    khatam(2);
}

if ($descr !~ /\S+/) {
    khatam(3);
}

if ($specs !~ /\S+/) {
    khatam(4);
}

if ($review !~ /\S+/) {
    khatam(5);
}

if (!defined($catid)) {
    khatam(6);
}

$sth = $dbh->prepare("select catid from prodcat where catid=$catid;");
$sth->execute();
if ( !defined($sth->fetchrow_arrayref()) )
{
    $sth->finish();
    khatam(6);
}
$sth->finish();

#find a new product id
$prodid1 = $prodid;

if ($prodid==0)
{
    #new product
    
    #find a new prodid and make sure there is no category with the same id
    while(1)
    {
	$prodid = get_next_id("select prodid from product where prodid=");
	$sth = $dbh->prepare("select catid from prodcat where catid=$prodid;");
	$sth->execute();
	if ($sth->fetchrow_arrayref())
	{
	    $sth->finish();
	    next;
	}
	else
	{
	    $sth->finish();
	    last;
	}
    }
}

$picuploaded = 0;
if (defined($infile))
{
    #so we have a picture file

    $tobefilename = '/pics/prod'.$prodid;

    #now whats the extension?
    $filename = param("picture"); #filename
  
    $startindex = -1;
    $t = index($filename, ".", 0);
    while($t != -1)
    {
	$startindex = $t;
	$t = index($filename, ".", $startindex+1);
    }
    
    if ($startindex != -1)
    {
	#yes there is a dot in the filename, so we assume the remaining string after the dot is the extension
	$tobefilename = $tobefilename.substr($filename, $startindex);
    }

    #copy the file to our file
    open (OUTFILE,">../htdocs".$tobefilename);
    binmode(OUTFILE);
    binmode($infile);
    while (read($infile,$buffer,1024)) {
	print OUTFILE $buffer;
    }
    close($infile);
    close(OUTFILE);

    $picuploaded = 1;
    $picture = $tobefilename;

}

#----------end of data validation


#store the data into the user table

if ($prodid1 == 0)
{
    #insert new product
    
    if ($picuploaded == 1)
    {
	$dbh->do("insert into product (prodid, name, descr, specs, review, price, picture, catid) VALUES ($prodid, \"$name\", \"$descr\", \"$specs\", \"$review\", $price, \"$picture\", $catid);");
    }
    else
    {
	$dbh->do("insert into product (prodid, name, descr, specs, review, price, catid) VALUES ($prodid, \"$name\", \"$descr\", \"$specs\", \"$review\", $price, $catid);");
    }
}
else
{
    #product already present, just update it
 
    if ($picuploaded == 1)
    {
	$dbh->do("update product SET name=\"$name\", descr=\"$descr\", specs=\"$specs\", review=\"$review\", price=$price, picture=\"$picture\", catid=$catid where prodid=$prodid;");
    }
    else
    {
	$dbh->do("update product SET name=\"$name\", descr=\"$descr\", specs=\"$specs\", review=\"$review\", price=$price, catid=$catid where prodid=$prodid;");
    }
}

$dbh->disconnect();

print redirect("adminmain.pl?sid=$sid");

exit(0);


sub khatam
{
    my $errnum = shift(@_);
    
    $dbh->disconnect();

    print redirect("editproduct.pl?sid=$sid&errnum=$errnum&prodid=$prodid");

    exit(0);
}
