#!/usr/local/bin/perl -w
#
# storeprofile.pl 
# accepts sid; toconfirmorder; toadmin; userid; usertype; all form elements
#
use CGI qw/:standard/;
use DBI;
use mylibrary;  #this contains some routines required many times

$sid = param("sid"); #this is the session id -- global variable

($return_val, $sid) = handle_session($sid);
if ($return_val == 1) 
{
    disp_message("Session has timed out");
    exit(1);
}

#NOTE: WE ARE NOT DISPLAYING ANY PAGE IN THIS SCRIPT
#THIS SCRIPT WILL ONLY PROCESS AND REDIRECT TO OTHER PAGES

##***** start the actual page

$toconfirmorder = param("toconfirmorder");
$toadmin = param("toadmin");
$name = param ("name");
$address = param ("address");
$city = param("city");
$state = param ("state");
$zip = param ("zip");
$phone = param ("phone");
$email = param ("email");
$cc = param ("cc");
$ccexp = param ("ccexp");
$username = param ("username");
$password = param ("password");
$userid = param("userid"); #the user to update the profile of; if null, then create a new profile
$usertype = param("usertype");

$name =~ s/\"/\'/g;$address =~ s/\"/\'/g;$city =~ s/\"/\'/g;$state =~ s/\"/\'/g;$zip =~ s/\"/\'/g;
$phone =~ s/\"/\'/g;$email =~ s/\"/\'/g;$cc =~ s/\"/\'/g;$ccexp =~ s/\"/\'/g;$username =~ s/\"/\'/g;
$password =~ s/\"/\'/g;

$dbh = DBI->connect ($glob_db_string, $glob_db_username, $glob_db_password, { PrintError => 0, RaiseError => 1} );

if (!defined($userid) || !defined($usertype))
{
    khatam(13);
}

if ($userid != 0 && $userid != get_session_user($sid))
{
    #someone is trying to create edit somebody else's profile
    #he can only be the administrator
    if (get_user_type(get_session_user($sid)) != 2) 
    { #hehe! somebody is trying spoof us!!!
	khatam(14);
    }
}

if ($usertype != 1 && $usertype != 2)
{
    $usertype = 1;
}

if ($usertype == 2)
{
    #only an admin can create an an admin profile
    if (get_user_type(get_session_user($sid)) != 2) 
    { #hehe! somebody is trying spoof us!!!
	$usertype = 1;
    }
}

if ($userid == 1000)
{
    if (get_session_user($sid) != 1000)
    {
    khatam(15);
    }

}

#----------start data validation
if (length($name) == 0 || length($name) > 28) {
    khatam(1);
}

if (length($address) == 0 || length($address) > 60) {
    khatam(2);
}

if (length($city) == 0 || length($city) > 20) {
    khatam(3);
}

if ( (length($state) != 2) || !($state =~ /[A-Za-z][A-Za-z]/ ) ) {
    khatam(4);
}

if ( (length($zip) != 5) || !($zip =~ /\d{5}/ ) ){
    khatam(5);
}

if ( (length($phone) != 10) || !($phone =~ /\d{10}/ ) ){
    khatam(6);
}

if ( (length($email) == 0 || length($email) > 28) || !( $email =~ /\A\S+\@\S+\.\S+\Z/  )  ) {
    khatam(7);
}

if ( (length($cc) < 9 || length($cc) > 10) || !($cc =~ /\d{10}/ ) ) {
    khatam(8);
}

if ( $ccexp =~ /\A(\d{1,2})\/(\d{1,2})\Z/ )
{
    if ( $1 <1 || $1 > 12 || $2 < 3 || $2 > 53 || ($2 == 3 && $1 < 7) )
    {
	khatam(9);
    }
}
else
{
    khatam(9);
}

if ( (length($password) < 3 || length($password) > 10) || !($password =~ /\A\w{3,}\Z/ ) ){
    khatam(10);
}

if ($userid==0)
{
    #this is a user creation
    
    if ( !($username =~ /\A\w{3,10}\Z/  ) )
    {
	khatam(11);
    }

    #check whether a user exists with the same username
    $sth = $dbh->prepare("select userid from user where username=\"$username\";");
    $sth->execute();
    if ( ($sth->fetchrow_arrayref()) )
    {
	#there is a user present
	$sth->finish();
	khatam(12);
    }
    $sth->finish();
    
}
#----------end of data validation


#store the data into the user table

if ($userid==0)
{
    #new user
    
    #find a new userid
    $userid = get_next_id("select userid from user where userid=");

    if ($usertype == 2) {
	$usertype = "admin";
    }
    else{
	$usertype = "user";
    }
	
    $dbh->do("insert into user (userid, name, address, city, state, zip, phone, email, cc, ccexp, usertype, prevcartid, username, password) VALUES ($userid, \"$name\", \"$address\", \"$city\", \"$state\", \"$zip\", \"$phone\", \"$email\", \"$cc\", \"$ccexp\", \"$usertype\", NULL, \"$username\", \"$password\");");

    if (!defined(get_session_user($sid)))
    {
	#set this session's userid to this userid if there is nobody logged in 
	$dbh->do("update session SET userid=$userid where sessionid=$sid;"); #so we are logged in! ;)
    }
	
}

else
{
    #user already present, just update him
    
    $dbh->do("update user SET name=\"$name\", address=\"$address\", city=\"$city\", state=\"$state\", zip=\"$zip\", phone=\"$phone\", email=\"$email\", cc=\"$cc\", ccexp=\"$ccexp\", password=\"$password\" where userid=$userid;");

}

$dbh->disconnect();

if ($toconfirmorder && $toconfirmorder != 0)
{
    print redirect("confirmorder.pl?sid=$sid");
}
elsif ($toadmin && $toadmin != 0)
{
    print redirect("adminmain.pl?sid=$sid");
}
else
{
    $t = get_session_lastitem($sid);
    print redirect("shop.pl?sid=$sid&pid=$t");

}

exit(0);


sub khatam
{
    my $errnum = shift(@_);
    
    $dbh->disconnect();

    my $str = "editprofile.pl?sid=$sid&errnum=$errnum";

    if ($toconfirmorder)
    {
	$str = $str."&toconfirmorder=$toconfirmorder";
    }
    
    if ($toadmin)
    {
	$str = $str."&toadmin=$toadmin";
    }
    
    if (($temp = get_session_user($sid)) && (get_user_type($temp) == 2))
    {
	$str = $str."&userid=$userid&usertype=$usertype";
    }
        
    print redirect($str);

    exit(0);
    
}
